# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`ssh`](#ssh): install and manage SSH server and client

### Defined types

* [`ssh::config_entry`](#ssh--config_entry): Create config entries in a users' ~/.ssh/config

### Data types

* [`SSH::Key_type`](#SSH--Key_type)
* [`Ssh::Log_level`](#Ssh--Log_level)
* [`Ssh::Permit_root_login`](#Ssh--Permit_root_login)
* [`Ssh::Syslog_facility`](#Ssh--Syslog_facility)
* [`Ssh::Yes_no`](#Ssh--Yes_no)

## Classes

### <a name="ssh"></a>`ssh`

install and manage SSH server and client

* **Note** default values for paramters are managed with hiera data, see files in the `data` directory.
Paramters marked SSH_CONFIG(5) or SSHD_CONFIG(5) are directly used in the configuration as described
by the corresponding openssh man page

#### Examples

##### Basic usage

```puppet
include ::ssh
```

#### Parameters

The following parameters are available in the `ssh` class:

* [`config_entries`](#-ssh--config_entries)
* [`hiera_merge`](#-ssh--hiera_merge)
* [`keys`](#-ssh--keys)
* [`manage_firewall`](#-ssh--manage_firewall)
* [`manage_root_ssh_config`](#-ssh--manage_root_ssh_config)
* [`manage_service`](#-ssh--manage_service)
* [`packages`](#-ssh--packages)
* [`permit_root_login`](#-ssh--permit_root_login)
* [`purge_keys`](#-ssh--purge_keys)
* [`root_ssh_config_content`](#-ssh--root_ssh_config_content)
* [`service_enable`](#-ssh--service_enable)
* [`service_ensure`](#-ssh--service_ensure)
* [`service_hasrestart`](#-ssh--service_hasrestart)
* [`service_hasstatus`](#-ssh--service_hasstatus)
* [`service_name`](#-ssh--service_name)
* [`ssh_config_ciphers`](#-ssh--ssh_config_ciphers)
* [`ssh_config_forward_agent`](#-ssh--ssh_config_forward_agent)
* [`ssh_config_forward_x11_trusted`](#-ssh--ssh_config_forward_x11_trusted)
* [`ssh_config_forward_x11`](#-ssh--ssh_config_forward_x11)
* [`ssh_config_global_known_hosts_file`](#-ssh--ssh_config_global_known_hosts_file)
* [`ssh_config_global_known_hosts_group`](#-ssh--ssh_config_global_known_hosts_group)
* [`ssh_config_global_known_hosts_list`](#-ssh--ssh_config_global_known_hosts_list)
* [`ssh_config_global_known_hosts_mode`](#-ssh--ssh_config_global_known_hosts_mode)
* [`ssh_config_global_known_hosts_owner`](#-ssh--ssh_config_global_known_hosts_owner)
* [`ssh_config_group`](#-ssh--ssh_config_group)
* [`ssh_config_hash_known_hosts`](#-ssh--ssh_config_hash_known_hosts)
* [`ssh_config_kexalgorithms`](#-ssh--ssh_config_kexalgorithms)
* [`ssh_config_macs`](#-ssh--ssh_config_macs)
* [`ssh_config_mode`](#-ssh--ssh_config_mode)
* [`ssh_config_owner`](#-ssh--ssh_config_owner)
* [`ssh_config_path`](#-ssh--ssh_config_path)
* [`ssh_config_proxy_command`](#-ssh--ssh_config_proxy_command)
* [`ssh_config_sendenv_xmodifiers`](#-ssh--ssh_config_sendenv_xmodifiers)
* [`ssh_config_server_alive_interval`](#-ssh--ssh_config_server_alive_interval)
* [`ssh_config_template`](#-ssh--ssh_config_template)
* [`ssh_config_user_known_hosts_file`](#-ssh--ssh_config_user_known_hosts_file)
* [`ssh_config_use_roaming`](#-ssh--ssh_config_use_roaming)
* [`sshd_acceptenv`](#-ssh--sshd_acceptenv)
* [`sshd_addressfamily`](#-ssh--sshd_addressfamily)
* [`sshd_allow_tcp_forwarding`](#-ssh--sshd_allow_tcp_forwarding)
* [`sshd_authorized_keys_command`](#-ssh--sshd_authorized_keys_command)
* [`sshd_authorized_keys_command_user`](#-ssh--sshd_authorized_keys_command_user)
* [`sshd_banner_content`](#-ssh--sshd_banner_content)
* [`sshd_banner_group`](#-ssh--sshd_banner_group)
* [`sshd_banner_mode`](#-ssh--sshd_banner_mode)
* [`sshd_banner_owner`](#-ssh--sshd_banner_owner)
* [`sshd_client_alive_count_max`](#-ssh--sshd_client_alive_count_max)
* [`sshd_client_alive_interval`](#-ssh--sshd_client_alive_interval)
* [`sshd_config_allowagentforwarding`](#-ssh--sshd_config_allowagentforwarding)
* [`sshd_config_allowgroups`](#-ssh--sshd_config_allowgroups)
* [`sshd_config_allowusers`](#-ssh--sshd_config_allowusers)
* [`sshd_config_authenticationmethods`](#-ssh--sshd_config_authenticationmethods)
* [`sshd_config_authkey_location`](#-ssh--sshd_config_authkey_location)
* [`sshd_config_authorized_principals_file`](#-ssh--sshd_config_authorized_principals_file)
* [`sshd_config_banner`](#-ssh--sshd_config_banner)
* [`sshd_config_challenge_resp_auth`](#-ssh--sshd_config_challenge_resp_auth)
* [`sshd_config_chrootdirectory`](#-ssh--sshd_config_chrootdirectory)
* [`sshd_config_ciphers`](#-ssh--sshd_config_ciphers)
* [`sshd_config_compression`](#-ssh--sshd_config_compression)
* [`sshd_config_denygroups`](#-ssh--sshd_config_denygroups)
* [`sshd_config_denyusers`](#-ssh--sshd_config_denyusers)
* [`sshd_config_forcecommand`](#-ssh--sshd_config_forcecommand)
* [`sshd_config_group`](#-ssh--sshd_config_group)
* [`sshd_config_hostcertificate`](#-ssh--sshd_config_hostcertificate)
* [`sshd_config_hostkey`](#-ssh--sshd_config_hostkey)
* [`sshd_config_kexalgorithms`](#-ssh--sshd_config_kexalgorithms)
* [`sshd_config_key_revocation_list`](#-ssh--sshd_config_key_revocation_list)
* [`sshd_config_loglevel`](#-ssh--sshd_config_loglevel)
* [`sshd_config_login_grace_time`](#-ssh--sshd_config_login_grace_time)
* [`sshd_config_macs`](#-ssh--sshd_config_macs)
* [`sshd_config_match`](#-ssh--sshd_config_match)
* [`sshd_config_maxauthtries`](#-ssh--sshd_config_maxauthtries)
* [`sshd_config_maxsessions`](#-ssh--sshd_config_maxsessions)
* [`sshd_config_maxstartups`](#-ssh--sshd_config_maxstartups)
* [`sshd_config_mode`](#-ssh--sshd_config_mode)
* [`sshd_config_owner`](#-ssh--sshd_config_owner)
* [`sshd_config_path`](#-ssh--sshd_config_path)
* [`sshd_config_permitemptypasswords`](#-ssh--sshd_config_permitemptypasswords)
* [`sshd_config_permittunnel`](#-ssh--sshd_config_permittunnel)
* [`sshd_config_permituserenvironment`](#-ssh--sshd_config_permituserenvironment)
* [`sshd_config_port`](#-ssh--sshd_config_port)
* [`sshd_config_print_last_log`](#-ssh--sshd_config_print_last_log)
* [`sshd_config_print_motd`](#-ssh--sshd_config_print_motd)
* [`sshd_config_serverkeybits`](#-ssh--sshd_config_serverkeybits)
* [`sshd_config_strictmodes`](#-ssh--sshd_config_strictmodes)
* [`sshd_config_subsystem_sftp`](#-ssh--sshd_config_subsystem_sftp)
* [`sshd_config_syslog_facility`](#-ssh--sshd_config_syslog_facility)
* [`sshd_config_tcp_keepalive`](#-ssh--sshd_config_tcp_keepalive)
* [`sshd_config_template`](#-ssh--sshd_config_template)
* [`sshd_config_trustedusercakeys`](#-ssh--sshd_config_trustedusercakeys)
* [`sshd_config_use_dns`](#-ssh--sshd_config_use_dns)
* [`sshd_config_use_privilege_separation`](#-ssh--sshd_config_use_privilege_separation)
* [`sshd_config_xauth_location`](#-ssh--sshd_config_xauth_location)
* [`sshd_gssapiauthentication`](#-ssh--sshd_gssapiauthentication)
* [`sshd_gssapicleanupcredentials`](#-ssh--sshd_gssapicleanupcredentials)
* [`sshd_gssapikeyexchange`](#-ssh--sshd_gssapikeyexchange)
* [`sshd_hostbasedauthentication`](#-ssh--sshd_hostbasedauthentication)
* [`sshd_ignorerhosts`](#-ssh--sshd_ignorerhosts)
* [`sshd_ignoreuserknownhosts`](#-ssh--sshd_ignoreuserknownhosts)
* [`sshd_kerberos_authentication`](#-ssh--sshd_kerberos_authentication)
* [`sshd_listen_address`](#-ssh--sshd_listen_address)
* [`sshd_pamauthenticationviakbdint`](#-ssh--sshd_pamauthenticationviakbdint)
* [`sshd_password_authentication`](#-ssh--sshd_password_authentication)
* [`sshd_pubkeyacceptedkeytypes`](#-ssh--sshd_pubkeyacceptedkeytypes)
* [`sshd_pubkeyauthentication`](#-ssh--sshd_pubkeyauthentication)
* [`sshd_use_pam`](#-ssh--sshd_use_pam)
* [`sshd_x11_forwarding`](#-ssh--sshd_x11_forwarding)
* [`sshd_x11_use_localhost`](#-ssh--sshd_x11_use_localhost)
* [`ssh_enable_ssh_keysign`](#-ssh--ssh_enable_ssh_keysign)
* [`ssh_gssapiauthentication`](#-ssh--ssh_gssapiauthentication)
* [`ssh_gssapidelegatecredentials`](#-ssh--ssh_gssapidelegatecredentials)
* [`ssh_hostbasedauthentication`](#-ssh--ssh_hostbasedauthentication)
* [`ssh_key_ensure`](#-ssh--ssh_key_ensure)
* [`ssh_key_import`](#-ssh--ssh_key_import)
* [`ssh_key_type`](#-ssh--ssh_key_type)
* [`ssh_package_adminfile`](#-ssh--ssh_package_adminfile)
* [`ssh_package_source`](#-ssh--ssh_package_source)
* [`ssh_sendenv`](#-ssh--ssh_sendenv)
* [`ssh_strict_host_key_checking`](#-ssh--ssh_strict_host_key_checking)

##### <a name="-ssh--config_entries"></a>`config_entries`

Data type: `Hash`

parameter for ssh::config_entry factory

Default value: `{}`

##### <a name="-ssh--hiera_merge"></a>`hiera_merge`

Data type: `Boolean`

merge all found instances of ssh::keys and ssh::config_entries in hiera if true

Default value: `false`

##### <a name="-ssh--keys"></a>`keys`

Data type: `Optional[Hash]`

keys for user's ~/.ssh/authorized_keys

Default value: `undef`

##### <a name="-ssh--manage_firewall"></a>`manage_firewall`

Data type: `Boolean`

enable/disable firewall rule for ports configured in `$sshd_config_port`

Default value: `false`

##### <a name="-ssh--manage_root_ssh_config"></a>`manage_root_ssh_config`

Data type: `Boolean`

enable/disable management fo root users ssh_config

Default value: `false`

##### <a name="-ssh--manage_service"></a>`manage_service`

Data type: `Boolean`

enable/disable management of sshd service

Default value: `true`

##### <a name="-ssh--packages"></a>`packages`

Data type: `Array[String]`

which packages to install

Default value: `['openssh-client', 'openssh-server']`

##### <a name="-ssh--permit_root_login"></a>`permit_root_login`

Data type: `Ssh::Permit_root_login`

SSHD_CONFIG(5) PermitRootLogin

Default value: `'yes'`

##### <a name="-ssh--purge_keys"></a>`purge_keys`

Data type: `Boolean`

enable/disable purging of all unmanaged ssh keys

Default value: `true`

##### <a name="-ssh--root_ssh_config_content"></a>`root_ssh_config_content`

Data type: `String`

content of ssh config file for the root user

Default value: `"# This file is being maintained by Puppet.\n# DO NOT EDIT\n"`

##### <a name="-ssh--service_enable"></a>`service_enable`

Data type: `Boolean`

enable parameter for sshd service resource

Default value: `true`

##### <a name="-ssh--service_ensure"></a>`service_ensure`

Data type: `String`

ensure parameter for sshd service resource

Default value: `'running'`

##### <a name="-ssh--service_hasrestart"></a>`service_hasrestart`

Data type: `Boolean`

hasrestart parameter for sshd service resource

Default value: `true`

##### <a name="-ssh--service_hasstatus"></a>`service_hasstatus`

Data type: `Boolean`

hasstatus parameter for sshd service resource

Default value: `true`

##### <a name="-ssh--service_name"></a>`service_name`

Data type: `String`

name name parameter for sshd service resource

Default value: `'sshd'`

##### <a name="-ssh--ssh_config_ciphers"></a>`ssh_config_ciphers`

Data type: `Optional[Array[String]]`

SSH_CONFIG(5) Ciphers

Default value: `undef`

##### <a name="-ssh--ssh_config_forward_agent"></a>`ssh_config_forward_agent`

Data type: `Optional[String]`

SSH_CONFIG(5) ForwardAgent

Default value: `undef`

##### <a name="-ssh--ssh_config_forward_x11_trusted"></a>`ssh_config_forward_x11_trusted`

Data type: `Optional[Enum['yes','no']]`

SSH_CONFIG(5) ForwardX11Trusted

Default value: `undef`

##### <a name="-ssh--ssh_config_forward_x11"></a>`ssh_config_forward_x11`

Data type: `Optional[String]`

SSH_CONFIG(5) ForwardX11

Default value: `undef`

##### <a name="-ssh--ssh_config_global_known_hosts_file"></a>`ssh_config_global_known_hosts_file`

Data type: `Stdlib::Absolutepath`

SSH_CONFIG(5) GlobalKnownHostsFile

Default value: `'/etc/ssh/ssh_known_hosts'`

##### <a name="-ssh--ssh_config_global_known_hosts_group"></a>`ssh_config_global_known_hosts_group`

Data type: `String`

group mode for GlobalKnownHostsFile

Default value: `'root'`

##### <a name="-ssh--ssh_config_global_known_hosts_list"></a>`ssh_config_global_known_hosts_list`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

extra elements to append to GlobalKnownHostsFile

Default value: `undef`

##### <a name="-ssh--ssh_config_global_known_hosts_mode"></a>`ssh_config_global_known_hosts_mode`

Data type: `Stdlib::Filemode`

file mode for GlobalKnownHostsFile

Default value: `'0644'`

##### <a name="-ssh--ssh_config_global_known_hosts_owner"></a>`ssh_config_global_known_hosts_owner`

Data type: `String`

owner for GlobalKnownHostsFile

Default value: `'root'`

##### <a name="-ssh--ssh_config_group"></a>`ssh_config_group`

Data type: `String`

group for ssh config file

Default value: `'root'`

##### <a name="-ssh--ssh_config_hash_known_hosts"></a>`ssh_config_hash_known_hosts`

Data type: `Optional[Enum['yes','no']]`

SSH_CONFIG(5) HashKnownHosts

Default value: `undef`

##### <a name="-ssh--ssh_config_kexalgorithms"></a>`ssh_config_kexalgorithms`

Data type: `Optional[Array[String]]`

SSH_CONFIG(5) KexAlgorithms

Default value: `undef`

##### <a name="-ssh--ssh_config_macs"></a>`ssh_config_macs`

Data type: `Optional[Array[String]]`

SSH_CONFIG(5) MACs

Default value: `undef`

##### <a name="-ssh--ssh_config_mode"></a>`ssh_config_mode`

Data type: `Stdlib::Filemode`

file mode for ssh config file

Default value: `'0644'`

##### <a name="-ssh--ssh_config_owner"></a>`ssh_config_owner`

Data type: `String`

owner for ssh config file

Default value: `'root'`

##### <a name="-ssh--ssh_config_path"></a>`ssh_config_path`

Data type: `String`

path for ssh config file

Default value: `'/etc/ssh/ssh_config'`

##### <a name="-ssh--ssh_config_proxy_command"></a>`ssh_config_proxy_command`

Data type: `Optional[String]`

SSH_CONFIG(5) ssh_config_proxy_command

Default value: `undef`

##### <a name="-ssh--ssh_config_sendenv_xmodifiers"></a>`ssh_config_sendenv_xmodifiers`

Data type: `Boolean`

SSH_CONFIG(5) ssh_config_sendenv_xmodifiers

Default value: `false`

##### <a name="-ssh--ssh_config_server_alive_interval"></a>`ssh_config_server_alive_interval`

Data type: `Optional[String]`

SSH_CONFIG(5) ssh_config_server_alive_interval

Default value: `undef`

##### <a name="-ssh--ssh_config_template"></a>`ssh_config_template`

Data type: `String`

puppet template to use for ssh config

Default value: `'ssh/ssh_config.erb'`

##### <a name="-ssh--ssh_config_user_known_hosts_file"></a>`ssh_config_user_known_hosts_file`

Data type: `Optional[Array[String]]`

SSH_CONFIG(5) UserKnownHostsFile

Default value: `undef`

##### <a name="-ssh--ssh_config_use_roaming"></a>`ssh_config_use_roaming`

Data type: `Optional[Enum['yes','no','unset']]`

SSH_CONFIG(5) UseRoaming

Default value: `undef`

##### <a name="-ssh--sshd_acceptenv"></a>`sshd_acceptenv`

Data type: `Boolean`

enable/disable AcceptEnv options for specifying environment variables

Default value: `true`

##### <a name="-ssh--sshd_addressfamily"></a>`sshd_addressfamily`

Data type: `Optional[Pattern[/^(any|inet|inet6)$/]]`

SSHD_CONFIG(5) sshd_addressfamily

Default value: `undef`

##### <a name="-ssh--sshd_allow_tcp_forwarding"></a>`sshd_allow_tcp_forwarding`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) sshd_allow_tcp_forwarding

Default value: `'yes'`

##### <a name="-ssh--sshd_authorized_keys_command"></a>`sshd_authorized_keys_command`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) AuthorizedKeysCommand

Default value: `undef`

##### <a name="-ssh--sshd_authorized_keys_command_user"></a>`sshd_authorized_keys_command_user`

Data type: `Optional[String]`

SSHD_CONFIG(5) AuthorizedKeysCommandUser

Default value: `undef`

##### <a name="-ssh--sshd_banner_content"></a>`sshd_banner_content`

Data type: `Optional[String]`

content of ssh banner file

Default value: `undef`

##### <a name="-ssh--sshd_banner_group"></a>`sshd_banner_group`

Data type: `String`

group of ssh banner file

Default value: `'root'`

##### <a name="-ssh--sshd_banner_mode"></a>`sshd_banner_mode`

Data type: `Stdlib::Filemode`

file mode of ssh banner file

Default value: `'0644'`

##### <a name="-ssh--sshd_banner_owner"></a>`sshd_banner_owner`

Data type: `String`

owner of ssh banner file

Default value: `'root'`

##### <a name="-ssh--sshd_client_alive_count_max"></a>`sshd_client_alive_count_max`

Data type: `Integer`

SSHD_CONFIG(5) ClientAliveCountMax

Default value: `3`

##### <a name="-ssh--sshd_client_alive_interval"></a>`sshd_client_alive_interval`

Data type: `Integer`

SSHD_CONFIG(5) ClientAliveInterval

Default value: `0`

##### <a name="-ssh--sshd_config_allowagentforwarding"></a>`sshd_config_allowagentforwarding`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) AllowAgentForwarding

Default value: `undef`

##### <a name="-ssh--sshd_config_allowgroups"></a>`sshd_config_allowgroups`

Data type: `Array[String]`

SSHD_CONFIG(5) AllowGroups

Default value: `[]`

##### <a name="-ssh--sshd_config_allowusers"></a>`sshd_config_allowusers`

Data type: `Array[String]`

SSHD_CONFIG(5) AllowUsers

Default value: `[]`

##### <a name="-ssh--sshd_config_authenticationmethods"></a>`sshd_config_authenticationmethods`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) AuthenticationMethods

Default value: `undef`

##### <a name="-ssh--sshd_config_authkey_location"></a>`sshd_config_authkey_location`

Data type: `Optional[String]`

SSHD_CONFIG(5) AuthorizedKeysFile

Default value: `undef`

##### <a name="-ssh--sshd_config_authorized_principals_file"></a>`sshd_config_authorized_principals_file`

Data type: `Optional[String]`

SSHD_CONFIG(5) AuthorizedPrincipalsFile

Default value: `undef`

##### <a name="-ssh--sshd_config_banner"></a>`sshd_config_banner`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) Banner

Default value: `undef`

##### <a name="-ssh--sshd_config_challenge_resp_auth"></a>`sshd_config_challenge_resp_auth`

Data type: `String`

SSHD_CONFIG(5) ChallengeResponseAuthentication

Default value: `'yes'`

##### <a name="-ssh--sshd_config_chrootdirectory"></a>`sshd_config_chrootdirectory`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) ChrootDirectory

Default value: `undef`

##### <a name="-ssh--sshd_config_ciphers"></a>`sshd_config_ciphers`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) Ciphers

Default value: `undef`

##### <a name="-ssh--sshd_config_compression"></a>`sshd_config_compression`

Data type: `Optional[Enum['yes','no','delayed']]`

SSHD_CONFIG(5) Compression

Default value: `undef`

##### <a name="-ssh--sshd_config_denygroups"></a>`sshd_config_denygroups`

Data type: `Array[String]`

SSHD_CONFIG(5) DenyGroups

Default value: `[]`

##### <a name="-ssh--sshd_config_denyusers"></a>`sshd_config_denyusers`

Data type: `Array[String]`

SSHD_CONFIG(5) DenyUsers

Default value: `[]`

##### <a name="-ssh--sshd_config_forcecommand"></a>`sshd_config_forcecommand`

Data type: `Optional[String]`

SSHD_CONFIG(5) DenyGroups

Default value: `undef`

##### <a name="-ssh--sshd_config_group"></a>`sshd_config_group`

Data type: `String`

group of sshd config file

Default value: `'root'`

##### <a name="-ssh--sshd_config_hostcertificate"></a>`sshd_config_hostcertificate`

Data type: `Optional[Array[Stdlib::Absolutepath]]`

SSHD_CONFIG(5) HostCertificate

Default value: `undef`

##### <a name="-ssh--sshd_config_hostkey"></a>`sshd_config_hostkey`

Data type: `Array[Stdlib::Absolutepath]`

SSHD_CONFIG(5) HostKey

Default value: `['/etc/ssh/ssh_host_rsa_key']`

##### <a name="-ssh--sshd_config_kexalgorithms"></a>`sshd_config_kexalgorithms`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) KexAlgorithms

Default value: `undef`

##### <a name="-ssh--sshd_config_key_revocation_list"></a>`sshd_config_key_revocation_list`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) RevokedKeys

Default value: `undef`

##### <a name="-ssh--sshd_config_loglevel"></a>`sshd_config_loglevel`

Data type: `Enum['QUIET', 'FATAL', 'ERROR', 'INFO', 'VERBOSE']`

SSHD_CONFIG(5) LogLevel

Default value: `'INFO'`

##### <a name="-ssh--sshd_config_login_grace_time"></a>`sshd_config_login_grace_time`

Data type: `String`

SSHD_CONFIG(5) LoginGraceTime

Default value: `'120'`

##### <a name="-ssh--sshd_config_macs"></a>`sshd_config_macs`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) MACs

Default value: `undef`

##### <a name="-ssh--sshd_config_match"></a>`sshd_config_match`

Data type: `Optional[Hash]`

SSHD_CONFIG(5) Hash for matches with nested arrays for options for the Match
directive for the SSH daemon. Match directive is supported on SSH >= 5.x.

Default value: `undef`

##### <a name="-ssh--sshd_config_maxauthtries"></a>`sshd_config_maxauthtries`

Data type: `Optional[Integer]`

SSHD_CONFIG(5) MaxAuthTries

Default value: `undef`

##### <a name="-ssh--sshd_config_maxsessions"></a>`sshd_config_maxsessions`

Data type: `Optional[Integer]`

SSHD_CONFIG(5) MaxSessions

Default value: `undef`

##### <a name="-ssh--sshd_config_maxstartups"></a>`sshd_config_maxstartups`

Data type: `Optional[Pattern[/^((\d+)|(\d+?:\d+?:\d+)?)$/]]`

SSHD_CONFIG(5) MaxStartups

Default value: `undef`

##### <a name="-ssh--sshd_config_mode"></a>`sshd_config_mode`

Data type: `Stdlib::Filemode`

file mode of sshd config file

Default value: `'0600'`

##### <a name="-ssh--sshd_config_owner"></a>`sshd_config_owner`

Data type: `String`

owner of sshd config file

Default value: `'root'`

##### <a name="-ssh--sshd_config_path"></a>`sshd_config_path`

Data type: `String`

path of sshd config file

Default value: `'/etc/ssh/sshd_config'`

##### <a name="-ssh--sshd_config_permitemptypasswords"></a>`sshd_config_permitemptypasswords`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) PermitEmptyPasswords

Default value: `undef`

##### <a name="-ssh--sshd_config_permittunnel"></a>`sshd_config_permittunnel`

Data type: `Optional[Enum['yes','no','point-to-point','ethernet']]`

SSHD_CONFIG(5) PermitTunnel

Default value: `undef`

##### <a name="-ssh--sshd_config_permituserenvironment"></a>`sshd_config_permituserenvironment`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) PermitUserEnvironment

Default value: `undef`

##### <a name="-ssh--sshd_config_port"></a>`sshd_config_port`

Data type: `Array[Stdlib::Port]`

SSHD_CONFIG(5) Port

Default value: `[22]`

##### <a name="-ssh--sshd_config_print_last_log"></a>`sshd_config_print_last_log`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) PrintLastLog

Default value: `undef`

##### <a name="-ssh--sshd_config_print_motd"></a>`sshd_config_print_motd`

Data type: `String`

SSHD_CONFIG(5) PrintMotd

Default value: `'yes'`

##### <a name="-ssh--sshd_config_serverkeybits"></a>`sshd_config_serverkeybits`

Data type: `Optional[String]`

SSHD_CONFIG(5) ServerKeyBits

Default value: `undef`

##### <a name="-ssh--sshd_config_strictmodes"></a>`sshd_config_strictmodes`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) StrictModes

Default value: `undef`

##### <a name="-ssh--sshd_config_subsystem_sftp"></a>`sshd_config_subsystem_sftp`

Data type: `String`

SSHD_CONFIG(5) Subsystem

Default value: `'/usr/lib/openssh/sftp-server'`

##### <a name="-ssh--sshd_config_syslog_facility"></a>`sshd_config_syslog_facility`

Data type: `String`

SSHD_CONFIG(5) SyslogFacility

Default value: `'AUTH'`

##### <a name="-ssh--sshd_config_tcp_keepalive"></a>`sshd_config_tcp_keepalive`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) TCPKeepAlive

Default value: `undef`

##### <a name="-ssh--sshd_config_template"></a>`sshd_config_template`

Data type: `String`

SSHD_CONFIG(5) puppet template to use for sshd config file

Default value: `'ssh/sshd_config.erb'`

##### <a name="-ssh--sshd_config_trustedusercakeys"></a>`sshd_config_trustedusercakeys`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) TrustedUserCAKeys

Default value: `undef`

##### <a name="-ssh--sshd_config_use_dns"></a>`sshd_config_use_dns`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) UseDNS

Default value: `undef`

##### <a name="-ssh--sshd_config_use_privilege_separation"></a>`sshd_config_use_privilege_separation`

Data type: `Optional[Enum['yes','no','sandbox']]`

SSHD_CONFIG(5) UsePrivilegeSeparation

Default value: `undef`

##### <a name="-ssh--sshd_config_xauth_location"></a>`sshd_config_xauth_location`

Data type: `Optional[Stdlib::Absolutepath]`

SSHD_CONFIG(5) XAuthLocation

Default value: `undef`

##### <a name="-ssh--sshd_gssapiauthentication"></a>`sshd_gssapiauthentication`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) GSSAPIAuthentication

Default value: `'yes'`

##### <a name="-ssh--sshd_gssapicleanupcredentials"></a>`sshd_gssapicleanupcredentials`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) GSSAPICleanupCredentials

Default value: `undef`

##### <a name="-ssh--sshd_gssapikeyexchange"></a>`sshd_gssapikeyexchange`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) GSSAPIKeyExchange

Default value: `undef`

##### <a name="-ssh--sshd_hostbasedauthentication"></a>`sshd_hostbasedauthentication`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) HostbasedAuthentication

Default value: `'no'`

##### <a name="-ssh--sshd_ignorerhosts"></a>`sshd_ignorerhosts`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) IgnoreRhosts

Default value: `'yes'`

##### <a name="-ssh--sshd_ignoreuserknownhosts"></a>`sshd_ignoreuserknownhosts`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) IgnoreUserKnownHosts

Default value: `'no'`

##### <a name="-ssh--sshd_kerberos_authentication"></a>`sshd_kerberos_authentication`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) KerberosAuthentication

Default value: `undef`

##### <a name="-ssh--sshd_listen_address"></a>`sshd_listen_address`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) ListenAddress

Default value: `undef`

##### <a name="-ssh--sshd_pamauthenticationviakbdint"></a>`sshd_pamauthenticationviakbdint`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) PAMAuthenticationViaKBDInt

Default value: `undef`

##### <a name="-ssh--sshd_password_authentication"></a>`sshd_password_authentication`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) PasswordAuthentication

Default value: `'yes'`

##### <a name="-ssh--sshd_pubkeyacceptedkeytypes"></a>`sshd_pubkeyacceptedkeytypes`

Data type: `Optional[Array[String]]`

SSHD_CONFIG(5) PubkeyAcceptedKeyTypes

Default value: `undef`

##### <a name="-ssh--sshd_pubkeyauthentication"></a>`sshd_pubkeyauthentication`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) PubkeyAuthentication

Default value: `'yes'`

##### <a name="-ssh--sshd_use_pam"></a>`sshd_use_pam`

Data type: `Optional[Enum['yes','no']]`

SSHD_CONFIG(5) UsePAM

Default value: `undef`

##### <a name="-ssh--sshd_x11_forwarding"></a>`sshd_x11_forwarding`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) X11Forwarding

Default value: `'yes'`

##### <a name="-ssh--sshd_x11_use_localhost"></a>`sshd_x11_use_localhost`

Data type: `Enum['yes','no']`

SSHD_CONFIG(5) X11UseLocalhost

Default value: `'yes'`

##### <a name="-ssh--ssh_enable_ssh_keysign"></a>`ssh_enable_ssh_keysign`

Data type: `Optional[Enum['yes','no']]`

SSH_CONFIG(5) EnableSSHKeysign

Default value: `undef`

##### <a name="-ssh--ssh_gssapiauthentication"></a>`ssh_gssapiauthentication`

Data type: `Enum['yes','no']`

SSH_CONFIG(5) GSSAPIAuthentication

Default value: `'yes'`

##### <a name="-ssh--ssh_gssapidelegatecredentials"></a>`ssh_gssapidelegatecredentials`

Data type: `Optional[Enum['yes','no']]`

SSH_CONFIG(5) GSSAPIDelegateCredentials

Default value: `undef`

##### <a name="-ssh--ssh_hostbasedauthentication"></a>`ssh_hostbasedauthentication`

Data type: `Optional[Enum['yes','no']]`

SSH_CONFIG(5) HostbasedAuthentication

Default value: `undef`

##### <a name="-ssh--ssh_key_ensure"></a>`ssh_key_ensure`

Data type: `String`

enable/disable to export node sshkey resource

Default value: `'present'`

##### <a name="-ssh--ssh_key_import"></a>`ssh_key_import`

Data type: `Boolean`

enable/disable to import all exported node sshkey resources

Default value: `true`

##### <a name="-ssh--ssh_key_type"></a>`ssh_key_type`

Data type: `SSH::Key_type`

encryption type for SSH key.

Default value: `'ssh-rsa'`

##### <a name="-ssh--ssh_package_adminfile"></a>`ssh_package_adminfile`

Data type: `Optional[Stdlib::Absolutepath]`

adminfile paramter for package resources

Default value: `undef`

##### <a name="-ssh--ssh_package_source"></a>`ssh_package_source`

Data type: `Optional[Stdlib::Absolutepath]`

source paramter for package resources

Default value: `undef`

##### <a name="-ssh--ssh_sendenv"></a>`ssh_sendenv`

Data type: `Boolean`

enable/disable of SendEnv options for specifying environment variables

Default value: `true`

##### <a name="-ssh--ssh_strict_host_key_checking"></a>`ssh_strict_host_key_checking`

Data type: `Optional[Enum['yes','no','ask']]`

SSH_CONFIG(5) StrictHostKeyChecking

Default value: `undef`

## Defined types

### <a name="ssh--config_entry"></a>`ssh::config_entry`

@ see https://man.openbsd.org/ssh_config

#### Examples

##### Basic usage

```puppet
ssh::config_entry { 'jenkins github.com':
 host  => 'github.com',
 lines => ["  IdentityFile /home/jenkins/.ssh/jenkins-gihub.key"],
 order => '20',
}
```

#### Parameters

The following parameters are available in the `ssh::config_entry` defined type:

* [`owner`](#-ssh--config_entry--owner)
* [`group`](#-ssh--config_entry--group)
* [`path`](#-ssh--config_entry--path)
* [`host`](#-ssh--config_entry--host)
* [`order`](#-ssh--config_entry--order)
* [`ensure`](#-ssh--config_entry--ensure)
* [`lines`](#-ssh--config_entry--lines)

##### <a name="-ssh--config_entry--owner"></a>`owner`

Data type: `String`



##### <a name="-ssh--config_entry--group"></a>`group`

Data type: `String`



##### <a name="-ssh--config_entry--path"></a>`path`

Data type: `String`



##### <a name="-ssh--config_entry--host"></a>`host`

Data type: `String`



##### <a name="-ssh--config_entry--order"></a>`order`

Data type: `Variant[String, Integer]`



Default value: `'10'`

##### <a name="-ssh--config_entry--ensure"></a>`ensure`

Data type: `String`



Default value: `'present'`

##### <a name="-ssh--config_entry--lines"></a>`lines`

Data type: `Array[String]`



Default value: `[]`

## Data types

### <a name="SSH--Key_type"></a>`SSH::Key_type`

The SSH::Key_type data type.

Alias of `Enum['ssh-rsa', 'rsa', 'ssh-dsa', 'dsa', 'ecdsa-sha2-nistp256', 'ssh-ed25519']`

### <a name="Ssh--Log_level"></a>`Ssh::Log_level`

The Ssh::Log_level data type.

Alias of `Enum['QUIET', 'FATAL', 'ERROR', 'INFO', 'VERBOSE', 'DEBUG', 'DEBUG1', 'DEBUG2', 'DEBUG3']`

### <a name="Ssh--Permit_root_login"></a>`Ssh::Permit_root_login`

The Ssh::Permit_root_login data type.

Alias of `Enum['yes', 'prohibit-password', 'without-password', 'forced-commands-only', 'no']`

### <a name="Ssh--Syslog_facility"></a>`Ssh::Syslog_facility`

The Ssh::Syslog_facility data type.

Alias of `Enum['DAEMON', 'USER', 'AUTH', 'LOCAL0', 'LOCAL1', 'LOCAL2', 'LOCAL3', 'LOCAL4', 'LOCAL5', 'LOCAL6', 'LOCAL7', 'AUTHPRIV']`

### <a name="Ssh--Yes_no"></a>`Ssh::Yes_no`

The Ssh::Yes_no data type.

Alias of `Enum['yes', 'no']`

